#ifndef CVISION_HH
#define CVISION_HH


/**
Permet le suivi dans l'image de points grÃ¢ce Ã  ViSP.
Utilisation d'un thread

 @author Nicolas Andreff <Nicolas.Andreff@ifma.fr>
*/

#include <pthread.h>



#include <stdio.h>
//#include <sstream>
//#include <iomanip>

#include <visp/vpDebug.h>
#include <visp/vpConfig.h>

#if (defined (VISP_HAVE_X11) || defined(VISP_HAVE_GTK) || defined(VISP_HAVE_GDI))

#include <visp/vpImage.h>
//#include <visp/vpImageIo.h>
#include <visp/vpDisplayX.h>
#include <visp/vpDisplayGTK.h>
#include <visp/vpDisplayGDI.h>
#include <visp/vpList.h>
#include <visp/vpDot2.h>
//#include <visp/vpParseArgv.h>
//#include <visp/vpIoTools.h>

#include <visp/vp1394Grabber.h>


class CVision
{
public:
  CVision();
  
  ~CVision();
  
  int InitCamera();
  void ArreterSuivi();
  int LancerSuivi();

  vpList<vpDot2>* Points();
  
protected:
  
  vp1394Grabber mCamera ;

  vpImage<unsigned char> mImage ; // L'image
  
  // L'affichage
#if defined VISP_HAVE_GTK
  vpDisplayGTK display;
#elif defined VISP_HAVE_X11
  vpDisplayX display;
#elif defined VISP_HAVE_GDI
  vpDisplayGDI display;
#endif

  bool mInit;

  vpDot2 d;
  vpList<vpDot2> * m_list_d; // La liste des points a suivre




  // Pour le thread
  bool mArretSuivi;
  int BoucleSuivi();
  friend void *LancerBoucleSuivi ( void* param );
  
};


#endif

#endif
