#include <iostream>
#include <sstream>



#include <visp/vpConfig.h>
#include <visp/vpDebug.h>

#if defined(VISP_HAVE_DC1394_1)

#include <visp/vp1394Grabber.h>
#include <visp/vpImage.h>
#include <visp/vpImageIo.h>
#include <visp/vpDisplay.h>
#include <visp/vpDisplayX.h>
#include <visp/vpTime.h>

#include "CGoughArt.hh"
#include "CVision.hh"

using namespace std;


int main(int argc,char** argv)
{

  CVision Vision;

  int erreur=Vision.InitCamera();
  if (erreur)
    {
      exit(-1);
    }

  Vision.LancerSuivi();

  vpList<vpDot2>* LesPoints=NULL;
  for (int i=0; i<10; i++)
    {
      usleep(1000000);


      LesPoints=Vision.Points();

      while (!LesPoints->outside()) {
          vpDot2 tmp_d;
          tmp_d = LesPoints->value() ;

	  std::cout << "Point " << i++ << " : " << tmp_d.get_u()
		    << " " << tmp_d.get_v() << std::endl;

          LesPoints->next() ;
        }

      LesPoints->kill();
      delete LesPoints;
    }
  
  Vision.ArreterSuivi();

  return 0;

  time_t maintenant;
  char ttdesuite[30];
  
  
  maintenant=time(NULL);
  sprintf(ttdesuite,"%s",ctime(&maintenant));
  
  
  char nomjour[4], mois[4], jour[3], heure[10];
  int annee;
  
  sscanf(ttdesuite,"%s%s%s%s%d", 
	 nomjour, mois, jour, heure, &annee);

  int hh, mm,ss;
  sscanf(heure,"%d:%d:%d",&hh,&mm,&ss);
  char ladate[40];
  sprintf(ladate,"%s%s%02d_%02dh%02d",jour, mois, annee-2000,hh,mm);

  char commande[120];
  sprintf(commande,"mkdir %s", ladate);
  system(commande);

  CGoughArt Robot;
  
  char NomFichier[80];
  char NomFichierRetour[85];

  if (argc < 2)
    {
      cout << "Nom du fichier contenant les positions articulaires ?" << endl;
      cin >> NomFichier;
    }
  else if (argc==3)
    {
      if (strcmp(argv[1],"-f")==0)
	{
	  strcpy(NomFichier, argv[2]);
	}
      else
	{
	  cout << "Usage: SequenceArt [-h|-f <NomFichier>]" << endl;
	  return -1;
	}
    }
  else 
    {
      cout << "Usage: SequenceArt [-h|-f <NomFichier>]" << endl;
      return -1;
    }


  ifstream PositionsLues(NomFichier);
  if (PositionsLues.bad())
    {
      cout << "Erreur a l'ouverture de " << NomFichier << endl;
      return -1;
    }

  sprintf(NomFichierRetour,"%s/art%s.data",ladate,ladate);

  ofstream PositionsRetour(NomFichierRetour);
  if (PositionsRetour.bad())
    {
      cout << "Erreur a l'ouverture de " << NomFichierRetour << endl;
      return -1;
    }

  int NbPositions;
 
  PositionsLues >> NbPositions;


  int nok=Robot.Ouvrir();

cout << "ici" << endl;
  if (nok<0)
    {
      printf("Erreur d'initialisation du robot\n");
      exit(0);
    }


 
  // Initialisation de la camera
  vpImage<unsigned char> I ;

  vp1394Grabber g ;

  try {
    g.open(I) ;
  }
  catch(...) {
    std::cout << "The program was stopped..." << std::endl;
    return 0;
  }

  try {
      g.setFramerate(34);
      //g.setNBuffers(1);
    }
    catch(...) {
      vpERROR_TRACE("The requested framerate is not supported by the camera");
      vpERROR_TRACE("The program was stopped...");
      exit(-1);
    }

  // Acquire an image to get the image size
  try{
      for (int j=0; j<3; j++) g.acquire(I) ;
  }
  catch(...)
  {
    vpERROR_TRACE(" Error caught during acquiring") ;
    return(-1) ;
  }

  std::cout << std::endl;
  std::cout << "Image size: width : " << I.getWidth() <<  " height: "
       << I.getHeight() << std::endl;

  vpDisplayX d;

  d.init(I, 100, 100, "1394 grabbing (greylevel)... ") ;
  vpDisplay::display(I) ;
  vpDisplay::flush(I) ;



  char nom_image[FILENAME_MAX];
  sprintf(nom_image,"%s/im",ladate);

  char nom_image_n[FILENAME_MAX];


  sprintf(nom_image_n,"%s%03d",nom_image,0);

  vpImageIo::writePGM(I,nom_image_n);      
  sprintf(commande,"mv %s %s.pgm; convert %s.pgm %s.gif; \\rm %s.pgm",nom_image_n,nom_image_n,nom_image_n,nom_image_n,nom_image_n);
  system(commande);


  for (int no_pos=0; no_pos<NbPositions; no_pos++)
    {

      int i;
      double L[6];

      cout << "Prochain arret : ";
      for (i=0; i<6; i++)
	{
	  PositionsLues >> L[i];
	  cout <<  L[i] << " ";
	  //L[i]/=1000;
	}
      cout << endl;

      cout << "Attente fin du mouvement..." << endl;

      Robot.EnvoyerTensionsCodeurs(L); //AllerEnPositionArticulaireAbsolue(L);
      //Robot.AttendreFinMvt();
      usleep(5000000);
      cout << "                           ... OK" << endl;

      double P[6];
      
      Robot.LireCodeurs(P);
      cout << "Position  atteinte : ";
      for (i=0; i<6; i++)
	{
	  PositionsRetour << P[i]*1000 << " ";
	  cout << P[i]*1000 << " ";
	}
      PositionsRetour << endl;
      cout << endl;

      sprintf(nom_image_n,"%s%03d",nom_image,no_pos+1);
       
      try{
        for (int j=0; j<3; j++) g.acquire(I) ;
         }
      catch(...)
      {
        vpERROR_TRACE(" Error caught during acquiring") ;
        return(-1) ;
      }
      vpDisplay::display(I) ;
      vpDisplay::flush(I) ;
	
      vpImageIo::writePGM(I,nom_image_n);      
   

      sprintf(commande,"mv %s %s.pgm; convert %s.pgm %s.gif; \\rm %s.pgm",nom_image_n,nom_image_n,nom_image_n,nom_image_n,nom_image_n);


      system(commande);

    }

  Robot.Fermer();
  return 0;    
}
#else
int
main()
{
  vpTRACE("Ieee 1394 grabber capabilities are not available...\n"
	  "You should install libdc1394-1 to use this example.") ;
}
#endif

